%bcond_without repolib

%global namedversion %{version}%{?namedreltag}

Name:           jsr-311
Version:        1.1.1
Release:        4%{?reltag}%{?dist}
Epoch:          0
Summary:        JAX-RS: Java API for RESTful Web Services
License:        CDDL
Group:          Development/Java
URL:            https://jsr311.dev.java.net
%if 0
/bin/rm -rf jsr311-api-1.1.1.tar.xz jsr311-api-1.1.1/ .gitignore
/usr/bin/svn -q export -r 619 http://svn.java.net/svn/jsr311~svn/tags/jsr311-api-1.1.1 jsr311-api-1.1.1/
/bin/tar caf jsr311-api-1.1.1.tar.xz jsr311-api-1.1.1/
/usr/bin/rhpkg new-sources jsr311-api-1.1.1.tar.xz
/usr/bin/rhpkg prep
%endif
Source0:        jsr311-api-1.1.1.tar.xz
Patch0:         0000-jsr311-api-pom.patch
#
Provides:       jsr311 = %{epoch}:%{version}-%{release}
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-default-skin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-remote-resources-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-source-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  surefire-junit3
BuildArch:      noarch
BuildRoot:      %{_tmppath}/jsr311-api-%{namedversion}-%{release}-root

%description
%{summary}.

%package -n jsr311-api
Summary:        JAX-RS: Java API for RESTful Web Services
Group:          Development/Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
BuildRequires:  junit >= 0:3.8.1
# FIXME: build this
%if 0
BuildRequires:  wagon-svn >= 0:1.8
%endif
BuildRequires:  maven-compiler-plugin >= 0:2.0.2
BuildRequires:  maven-jar-plugin >= 0:2.2
BuildRequires:  buildnumber-maven-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-source-plugin
BuildRequires:  maven-bundle-plugin

%description -n jsr311-api
%{summary}.

%package -n jsr311-api-javadoc
Summary:        Javadoc for JAX-RS: Java API for RESTful Web Services
Group:          Development/Documentation
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description -n jsr311-api-javadoc
%{summary}.

%package -n %{name}-javadoc
Summary:        Javadoc for JAX-RS: Java API for RESTful Web Services
Group:          Development/Documentation
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description -n %{name}-javadoc
%{summary}.

%package -n jsr311-api-site
Summary:        Site for jsr311-api
Group:          Development/Documentation
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       jsr311-api-javadoc = %{epoch}:%{version}-%{release}

%description -n jsr311-api-site
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n jsr311-api-%{namedversion}
%patch0 -p1 -b .0000~

%build
export LC_ALL=en_US.UTF-8
export MAVEN_REPO_LOCAL=${PWD}/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=remote-repository::default::file://${PWD}/maven2-brew
export MAVEN_OPTS=
%{_bindir}/mvn-jpp -B -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -DperformRelease deploy javadoc:aggregate site

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p maven2-brew/javax/ws/rs/jsr311-api/%{namedversion}/jsr311-api-%{namedversion}.jar %{buildroot}%{_javadir}/jsr311-api-%{namedversion}.jar
%{__cp} -p maven2-brew/javax/ws/rs/jsr311-api/%{namedversion}/jsr311-api-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/jsr311-api-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/javax/ws/rs/jsr311-api/%{namedversion}/jsr311-api-%{namedversion}-sources.jar %{buildroot}%{_javadir}/jsr311-api-%{namedversion}-sources.jar
# FIXME: jars backwards compat
pushd %{buildroot}%{_javadir}
%{__ln_s} jsr311-api-%{namedversion}.jar jsr311-%{namedversion}.jar
%{__ln_s} jsr311-api-%{namedversion}.jar jsr-311-%{namedversion}.jar
%{__ln_s} jsr311-api-%{namedversion}-sources.jar jsr311-%{namedversion}-sources.jar
%{__ln_s} jsr311-api-%{namedversion}-sources.jar jsr-311-%{namedversion}-sources.jar
popd
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p maven2-brew/javax/ws/rs/jsr311-api/%{namedversion}/jsr311-api-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-jsr311-api.pom

# depmaps
%add_to_maven_depmap javax.ws.rs jsr311-api %{namedversion} JPP jsr311-api
[ %{name} = "jsr311-api" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/jsr311-api

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/jsr311-api-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/jsr311-api-%{namedversion}
%{__ln_s} jsr311-api-%{namedversion} %{buildroot}%{_javadocdir}/jsr311-api

# FIXME: javadoc backwards compat
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

# site
%{__mkdir_p} %{buildroot}%{_docdir}/jsr311-api-%{namedversion}
%{__cp} -pr target/site/* %{buildroot}%{_docdir}/jsr311-api-%{namedversion}
%{__rm} -r %{buildroot}%{_docdir}/jsr311-api-%{namedversion}/apidocs
%{__ln_s} %{_javadocdir}/jsr311-api %{buildroot}%{_docdir}/jsr311-api-%{namedversion}/apidocs
%{__ln_s} jsr311-api-%{namedversion} %{buildroot}%{_docdir}/jsr311-api

# repolib
%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%post -n jsr311-api
%update_maven_depmap

%postun -n jsr311-api
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc README.txt
%{_javadir}/jsr311-api-%{namedversion}.jar
%{_javadir}/jsr311-api.jar
%{_javadir}/jsr311-%{namedversion}.jar
%{_javadir}/jsr311.jar
%{_javadir}/jsr-311-%{namedversion}.jar
%{_javadir}/jsr-311.jar
%{_javadir}/jsr311-api-%{namedversion}-sources.jar
%{_javadir}/jsr311-api-sources.jar
%{_javadir}/jsr311-%{namedversion}-sources.jar
%{_javadir}/jsr311-sources.jar
%{_javadir}/jsr-311-%{namedversion}-sources.jar
%{_javadir}/jsr-311-sources.jar
%{_mavenpomdir}/JPP-jsr311-api.pom
%{_mavendepmapfragdir}/jsr311-api

%files -n jsr311-api
%defattr(0644,root,root,0755)
%{_javadir}/jsr311-api-%{namedversion}.jar
%{_javadir}/jsr311-api.jar
%{_javadir}/jsr311-api-%{namedversion}-sources.jar
%{_javadir}/jsr311-api-sources.jar
%{_mavenpomdir}/JPP-jsr311-api.pom
%{_mavendepmapfragdir}/jsr311-api

%files -n jsr311-api-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/jsr311-api-%{namedversion}
%{_javadocdir}/jsr311-api

%files -n %{name}-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%{_javadir}/jsr311-api-%{namedversion}-javadoc.jar
%{_javadir}/jsr311-api-javadoc.jar

%files -n jsr311-api-site
%defattr(0644,root,root,0755)
%{_docdir}/jsr311-api-%{namedversion}
%{_docdir}/jsr311-api

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Tue Aug 27 2013 David Walluck <dwalluck@redhat.com> 0:1.1.1-4
- add properly named jsr311-api
- add properly named jsr311-api-javadoc package and fix dir name
- add site package, but %%doc README.txt conflicts
- fix repolib file ownership
- fix scm section in pom (fixes buildnumber-maven-plugin)
- enable buildnumber-maven-plugin
- enable maven-bundle-plugin
- update Group
- remove obsolete jsr-311-1.0-pom-xml.patch
- remove unnecessary jsr-311-jpp-depmap.xml and jsr-311-settings.xml
- fix changelog
- fix macro in changelog

* Wed Oct 19 2011 Yong Yang <yyang@redhat.com> 0:1.1.1-3
- Fix depmap groupId

* Wed Oct 19 2011 Yong Yang <yyang@redhat.com> 0:1.1.1-2
- Fix depmap groupId

* Wed Oct 19 2011 Yong Yang <yyang@redhat.com> 0:1.1.1-1
- Upgrade to 1.1.1
- Add repolib
- Remove gcj_support

* Tue Feb 02 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0-2.1
- Disable aot Compiler

* Wed Aug 05 2009 Yong Yang <yyang@redhat.com> 0:1.0-2
- Fix %%{Summary}

* Mon Aug 03 2009 Yong Yang <yyang@redhat.com> 0:1.0-1
- First release
